searchNodes=[{"doc":"A module for working with the JSON API specification in Elixir","ref":"JSONAPI.html","title":"JSONAPI","type":"module"},{"doc":"Returns the configured JSON encoding library for JSONAPI. To customize the JSON library, including the following in your config/config.exs : config :jsonapi , :json_library , Jason","ref":"JSONAPI.html#json_library/0","title":"JSONAPI.json_library/0","type":"function"},{"doc":"This returns the MIME type for JSONAPIs","ref":"JSONAPI.html#mime_type/0","title":"JSONAPI.mime_type/0","type":"function"},{"doc":"Configuration struct containing JSON API information for a request","ref":"JSONAPI.Config.html","title":"JSONAPI.Config","type":"module"},{"doc":"","ref":"JSONAPI.Config.html#t:t/0","title":"JSONAPI.Config.t/0","type":"type"},{"doc":"Provides content type negotiation by validating the content-type and accept headers. The proper jsonapi.org content type is application/vnd.api+json . As per the spec This plug does three things: Returns 415 unless the content-type header is correct. Returns 406 unless the accept header is correct. Registers a before send hook to set the content-type if not already set.","ref":"JSONAPI.ContentTypeNegotiation.html","title":"JSONAPI.ContentTypeNegotiation","type":"module"},{"doc":"","ref":"JSONAPI.ContentTypeNegotiation.html#call/2","title":"JSONAPI.ContentTypeNegotiation.call/2","type":"function"},{"doc":"","ref":"JSONAPI.ContentTypeNegotiation.html#init/1","title":"JSONAPI.ContentTypeNegotiation.init/1","type":"function"},{"doc":"Generate warnings in places where we want to deprecate functions or struct parameters","ref":"JSONAPI.Deprecation.html","title":"JSONAPI.Deprecation","type":"module"},{"doc":"Generates a deprecation warning for using fields[relationship_key] instead of fields[type] when parsing query parameters.","ref":"JSONAPI.Deprecation.html#warn/1","title":"JSONAPI.Deprecation.warn/1","type":"function"},{"doc":"This plug flattens incoming params for ease of use when casting to changesets. As a result, you are able to pattern match specific attributes in your controller actions. Note that this Plug will only deserialize your payload when the request's content type is for a JSON:API request (i.e. &quot;application/vnd.api+json&quot;). All other content types will be ignored. Example For example these params: %{ &quot;data&quot; =&gt; %{ &quot;id&quot; =&gt; &quot;1&quot; , &quot;type&quot; =&gt; &quot;user&quot; , &quot;attributes&quot; =&gt; %{ &quot;foo-bar&quot; =&gt; true } , &quot;relationships&quot; =&gt; %{ &quot;baz&quot; =&gt; %{ &quot;data&quot; =&gt; %{ &quot;id&quot; =&gt; &quot;2&quot; , &quot;type&quot; =&gt; &quot;baz&quot; } } } } } are transformed to: %{ &quot;id&quot; =&gt; &quot;1&quot; , &quot;type&quot; =&gt; &quot;user&quot; &quot;foo-bar&quot; =&gt; true , &quot;baz-id&quot; =&gt; &quot;2&quot; } Usage Just include in your plug stack after a json parser: plug Plug.Parsers , parsers : [ :json ] , json_decoder : Jason plug JSONAPI.Deserializer or a part of your Controller plug pipeline plug JSONAPI.Deserializer In addition, if you want to underscore your parameters plug JSONAPI.Deserializer plug JSONAPI.UnderscoreParameters","ref":"JSONAPI.Deserializer.html","title":"JSONAPI.Deserializer","type":"module"},{"doc":"","ref":"JSONAPI.Deserializer.html#call/2","title":"JSONAPI.Deserializer.call/2","type":"function"},{"doc":"","ref":"JSONAPI.Deserializer.html#init/1","title":"JSONAPI.Deserializer.init/1","type":"function"},{"doc":"A helper Plug to enforce the JSON API specification","ref":"JSONAPI.EnsureSpec.html","title":"JSONAPI.EnsureSpec","type":"module"},{"doc":"Callback implementation for Plug.call/2 .","ref":"JSONAPI.EnsureSpec.html#call/2","title":"JSONAPI.EnsureSpec.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1 .","ref":"JSONAPI.EnsureSpec.html#init/1","title":"JSONAPI.EnsureSpec.init/1","type":"function"},{"doc":"","ref":"JSONAPI.ErrorView.html","title":"JSONAPI.ErrorView","type":"module"},{"doc":"","ref":"JSONAPI.ErrorView.html#build_error/5","title":"JSONAPI.ErrorView.build_error/5","type":"function"},{"doc":"","ref":"JSONAPI.ErrorView.html#incorrect_content_type/0","title":"JSONAPI.ErrorView.incorrect_content_type/0","type":"function"},{"doc":"","ref":"JSONAPI.ErrorView.html#malformed_id/0","title":"JSONAPI.ErrorView.malformed_id/0","type":"function"},{"doc":"","ref":"JSONAPI.ErrorView.html#mismatched_id/0","title":"JSONAPI.ErrorView.mismatched_id/0","type":"function"},{"doc":"","ref":"JSONAPI.ErrorView.html#missing_data_attributes_param/0","title":"JSONAPI.ErrorView.missing_data_attributes_param/0","type":"function"},{"doc":"","ref":"JSONAPI.ErrorView.html#missing_data_id_param/0","title":"JSONAPI.ErrorView.missing_data_id_param/0","type":"function"},{"doc":"","ref":"JSONAPI.ErrorView.html#missing_data_param/0","title":"JSONAPI.ErrorView.missing_data_param/0","type":"function"},{"doc":"","ref":"JSONAPI.ErrorView.html#missing_data_type_param/0","title":"JSONAPI.ErrorView.missing_data_type_param/0","type":"function"},{"doc":"","ref":"JSONAPI.ErrorView.html#missing_id/0","title":"JSONAPI.ErrorView.missing_id/0","type":"function"},{"doc":"","ref":"JSONAPI.ErrorView.html#missing_relationship_data_id_param_error_attrs/1","title":"JSONAPI.ErrorView.missing_relationship_data_id_param_error_attrs/1","type":"function"},{"doc":"","ref":"JSONAPI.ErrorView.html#missing_relationship_data_param_error_attrs/1","title":"JSONAPI.ErrorView.missing_relationship_data_param_error_attrs/1","type":"function"},{"doc":"","ref":"JSONAPI.ErrorView.html#missing_relationship_data_type_param_error_attrs/1","title":"JSONAPI.ErrorView.missing_relationship_data_type_param_error_attrs/1","type":"function"},{"doc":"","ref":"JSONAPI.ErrorView.html#relationships_missing_object/0","title":"JSONAPI.ErrorView.relationships_missing_object/0","type":"function"},{"doc":"","ref":"JSONAPI.ErrorView.html#send_error/2","title":"JSONAPI.ErrorView.send_error/2","type":"function"},{"doc":"","ref":"JSONAPI.ErrorView.html#send_error/3","title":"JSONAPI.ErrorView.send_error/3","type":"function"},{"doc":"","ref":"JSONAPI.ErrorView.html#serialize_error/1","title":"JSONAPI.ErrorView.serialize_error/1","type":"function"},{"doc":"","ref":"JSONAPI.ErrorView.html#serialize_errors/1","title":"JSONAPI.ErrorView.serialize_errors/1","type":"function"},{"doc":"","ref":"JSONAPI.ErrorView.html#to_many_relationships_payload_for_standard_endpoint/0","title":"JSONAPI.ErrorView.to_many_relationships_payload_for_standard_endpoint/0","type":"function"},{"doc":"","ref":"JSONAPI.ErrorView.html#t:error_attrs/0","title":"JSONAPI.ErrorView.error_attrs/0","type":"type"},{"doc":"","ref":"JSONAPI.Exceptions.html","title":"JSONAPI.Exceptions","type":"module"},{"doc":"Enforces the JSONAPI format of {&quot;data&quot; =&gt; {&quot;attributes&quot; =&gt; ...}} for request bodies","ref":"JSONAPI.FormatRequired.html","title":"JSONAPI.FormatRequired","type":"module"},{"doc":"","ref":"JSONAPI.FormatRequired.html#call/2","title":"JSONAPI.FormatRequired.call/2","type":"function"},{"doc":"","ref":"JSONAPI.FormatRequired.html#init/1","title":"JSONAPI.FormatRequired.init/1","type":"function"},{"doc":"Ensure that the URL id matches the id in the request body and is a string","ref":"JSONAPI.IdRequired.html","title":"JSONAPI.IdRequired","type":"module"},{"doc":"","ref":"JSONAPI.IdRequired.html#call/2","title":"JSONAPI.IdRequired.call/2","type":"function"},{"doc":"","ref":"JSONAPI.IdRequired.html#init/1","title":"JSONAPI.IdRequired.init/1","type":"function"},{"doc":"Pagination strategy behaviour","ref":"JSONAPI.Paginator.html","title":"JSONAPI.Paginator","type":"behaviour"},{"doc":"","ref":"JSONAPI.Paginator.html#c:paginate/5","title":"JSONAPI.Paginator.paginate/5","type":"callback"},{"doc":"","ref":"JSONAPI.Paginator.html#t:links/0","title":"JSONAPI.Paginator.links/0","type":"type"},{"doc":"","ref":"JSONAPI.Paginator.html#t:options/0","title":"JSONAPI.Paginator.options/0","type":"type"},{"doc":"","ref":"JSONAPI.Paginator.html#t:page/0","title":"JSONAPI.Paginator.page/0","type":"type"},{"doc":"","ref":"JSONAPI.Paginator.html#t:params/0","title":"JSONAPI.Paginator.params/0","type":"type"},{"doc":"Implements a fully JSONAPI V1 spec for parsing a complex query string via the query_params field from a Plug.Conn struct and returning Elixir datastructures. The purpose is to validate and encode incoming queries and fail quickly. Primarialy this handles: sorts include filtering sparse fieldsets pagination This Plug works in conjunction with a JSONAPI.View as well as some Plug defined configuration. In your controller you may add: plug JSONAPI.QueryParser , filter : ~w(title) , sort : ~w(created_at title) , include : ~w(others) # optionally specify a list of allowed includes. view : MyView If you specify which includes are allowed, any include name not in the list will produce an error. If you omit the include list then all relationships specified by the given resource will be allowed. If your controller's index function receives a query with params inside those bounds it will build a JSONAPI.Config that has all the validated and parsed fields for your usage. The final configuration will be added to assigns jsonapi_query . The final output will be a JSONAPI.Config struct and will look similar to the following: % JSONAPI.Config { view : MyView , opts : [ view : MyView , sort : [ &quot;created_at&quot; , &quot;title&quot; ] , filter : [ &quot;title&quot; ] ] , sort : [ desc : :created_at ] # Easily insertable into an ecto order_by, filter : [ title : &quot;my title&quot; ] # Easily reduceable into ecto where clauses include : [ comments : :user ] # Easily insertable into a Repo.preload, fields : %{ &quot;myview&quot; =&gt; [ :id , :text ] , &quot;comment&quot; =&gt; [ :id , :body ] , page : %{ limit : limit , offset : offset , page : page , size : size , cursor : cursor } } } The final result should allow you to build a query quickly and with little overhead. Sparse Fieldsets Sparse fieldsets are supported. By default your response will include all available fields. Note that the query to your database is left to you. Should you want to query your DB for specific fields JSONAPI.Config.fields will return the requested fields for each resource (see above example). Options :view - The JSONAPI View which is the basis for this plug. :sort - List of atoms which define which fields can be sorted on. :filter - List of atoms which define which fields can be filtered on. Dasherized Fields Note that if your API is returning dasherized fields (e.g. &quot;dog-breed&quot;: &quot;Corgi&quot; ) we recommend that you include the JSONAPI.UnderscoreParameters Plug in your API's pipeline with the replace_query_params option set to true . This will underscore fields for easier operations in your code. For more details please see JSONAPI.UnderscoreParameters .","ref":"JSONAPI.QueryParser.html","title":"JSONAPI.QueryParser","type":"module"},{"doc":"","ref":"JSONAPI.QueryParser.html#build_sort/2","title":"JSONAPI.QueryParser.build_sort/2","type":"function"},{"doc":"","ref":"JSONAPI.QueryParser.html#get_valid_fields_for_type/2","title":"JSONAPI.QueryParser.get_valid_fields_for_type/2","type":"function"},{"doc":"","ref":"JSONAPI.QueryParser.html#get_view_for_type/2","title":"JSONAPI.QueryParser.get_view_for_type/2","type":"function"},{"doc":"","ref":"JSONAPI.QueryParser.html#handle_include/2","title":"JSONAPI.QueryParser.handle_include/2","type":"function"},{"doc":"","ref":"JSONAPI.QueryParser.html#handle_nested_include/3","title":"JSONAPI.QueryParser.handle_nested_include/3","type":"function"},{"doc":"","ref":"JSONAPI.QueryParser.html#parse_fields/2","title":"JSONAPI.QueryParser.parse_fields/2","type":"function"},{"doc":"","ref":"JSONAPI.QueryParser.html#parse_filter/2","title":"JSONAPI.QueryParser.parse_filter/2","type":"function"},{"doc":"","ref":"JSONAPI.QueryParser.html#parse_include/2","title":"JSONAPI.QueryParser.parse_include/2","type":"function"},{"doc":"","ref":"JSONAPI.QueryParser.html#parse_pagination/2","title":"JSONAPI.QueryParser.parse_pagination/2","type":"function"},{"doc":"","ref":"JSONAPI.QueryParser.html#parse_sort/2","title":"JSONAPI.QueryParser.parse_sort/2","type":"function"},{"doc":"Simply add this plug to your endpoint or your router :api pipeline and it will ensure you return the correct response type. If you need to override the response type simple set conn.assigns[:override_jsonapi] and this will be skipped.","ref":"JSONAPI.ResponseContentType.html","title":"JSONAPI.ResponseContentType","type":"module"},{"doc":"Callback implementation for Plug.call/2 .","ref":"JSONAPI.ResponseContentType.html#call/2","title":"JSONAPI.ResponseContentType.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1 .","ref":"JSONAPI.ResponseContentType.html#init/1","title":"JSONAPI.ResponseContentType.init/1","type":"function"},{"doc":"Serialize a map of data into a properly formatted JSON API response object","ref":"JSONAPI.Serializer.html","title":"JSONAPI.Serializer","type":"module"},{"doc":"","ref":"JSONAPI.Serializer.html#build_relationships/5","title":"JSONAPI.Serializer.build_relationships/5","type":"function"},{"doc":"","ref":"JSONAPI.Serializer.html#build_relationships/7","title":"JSONAPI.Serializer.build_relationships/7","type":"function"},{"doc":"","ref":"JSONAPI.Serializer.html#data_loaded?/1","title":"JSONAPI.Serializer.data_loaded?/1","type":"function"},{"doc":"","ref":"JSONAPI.Serializer.html#encode_data/5","title":"JSONAPI.Serializer.encode_data/5","type":"function"},{"doc":"","ref":"JSONAPI.Serializer.html#encode_rel_data/2","title":"JSONAPI.Serializer.encode_rel_data/2","type":"function"},{"doc":"","ref":"JSONAPI.Serializer.html#encode_relation/1","title":"JSONAPI.Serializer.encode_relation/1","type":"function"},{"doc":"","ref":"JSONAPI.Serializer.html#encode_relationships/4","title":"JSONAPI.Serializer.encode_relationships/4","type":"function"},{"doc":"Given the relationship config entry provided by a JSONAPI.View, produce the extrapolated config tuple containing: The name of the relationship to be used when serializing The key in the data the relationship is found under The relationship resource's JSONAPI.View module A boolean for whether the relationship is included by default or not","ref":"JSONAPI.Serializer.html#extrapolate_relationship_config/1","title":"JSONAPI.Serializer.extrapolate_relationship_config/1","type":"function"},{"doc":"","ref":"JSONAPI.Serializer.html#flatten_included/1","title":"JSONAPI.Serializer.flatten_included/1","type":"function"},{"doc":"Takes a view, data and a optional plug connection and returns a fully JSONAPI Serialized document. This assumes you are using the JSONAPI.View and have data in maps or structs. Please refer to JSONAPI.View for more information. If you are in interested in relationships and includes you may also want to reference the JSONAPI.QueryParser .","ref":"JSONAPI.Serializer.html#serialize/5","title":"JSONAPI.Serializer.serialize/5","type":"function"},{"doc":"","ref":"JSONAPI.Serializer.html#t:document/0","title":"JSONAPI.Serializer.document/0","type":"type"},{"doc":"Takes dasherized JSON:API params and converts them to underscored params. Add this to your API's pipeline to aid in dealing with incoming parameters such as query params or data. By default the newly underscored params will only replace the existing params field of the Plug.Conn struct, but leave the query_params and body_params untouched. If you are using the JSONAPI.QueryParser and need to also have the query_params on the Plug.Conn updated, set the replace_query_params option to true . Note that this Plug will only underscore parameters when the request's content type is for a JSON:API request (i.e. &quot;application/vnd.api+json&quot;). All other content types will be ignored. Options :replace_query_params - When true , it will replace the query_params field in the Plug.Conn struct. This is useful when you have downstream code which is expecting underscored fields in query_params , and not just in params . Defaults to false . Example %{ &quot;data&quot; =&gt; %{ &quot;attributes&quot; =&gt; %{ &quot;foo-bar&quot; =&gt; true } } } are transformed to: %{ &quot;data&quot; =&gt; %{ &quot;attributes&quot; =&gt; %{ &quot;foo_bar&quot; =&gt; true } } } Moreover, with a GET request like: GET / example? filters [ dog - breed ] = Corgi Without this Plug your index action would look like: def index ( conn , %{ &quot;filters&quot; =&gt; %{ &quot;dog-breed&quot; =&gt; &quot;Corgi&quot; } } ) And with this Plug: def index ( conn , %{ &quot;filters&quot; =&gt; %{ &quot;dog_breed&quot; =&gt; &quot;Corgi&quot; } } ) Your API's pipeline might look something like this: # e.g. a Phoenix app pipeline :api do plug JSONAPI.EnforceSpec plug JSONAPI.UnderscoreParameters end","ref":"JSONAPI.UnderscoreParameters.html","title":"JSONAPI.UnderscoreParameters","type":"module"},{"doc":"Converts a Map representation of the JSON:API resource object format into a flat Map convenient for changeset casting.","ref":"JSONAPI.Utils.DataToParams.html","title":"JSONAPI.Utils.DataToParams","type":"module"},{"doc":"","ref":"JSONAPI.Utils.DataToParams.html#process/1","title":"JSONAPI.Utils.DataToParams.process/1","type":"function"},{"doc":"Internal utility for building trees of resource relationships","ref":"JSONAPI.Utils.IncludeTree.html","title":"JSONAPI.Utils.IncludeTree","type":"module"},{"doc":"","ref":"JSONAPI.Utils.IncludeTree.html#build_tree/2","title":"JSONAPI.Utils.IncludeTree.build_tree/2","type":"function"},{"doc":"","ref":"JSONAPI.Utils.IncludeTree.html#get_base_relationships/1","title":"JSONAPI.Utils.IncludeTree.get_base_relationships/1","type":"function"},{"doc":"","ref":"JSONAPI.Utils.IncludeTree.html#member_of_tree?/2","title":"JSONAPI.Utils.IncludeTree.member_of_tree?/2","type":"function"},{"doc":"","ref":"JSONAPI.Utils.IncludeTree.html#put_as_tree/3","title":"JSONAPI.Utils.IncludeTree.put_as_tree/3","type":"function"},{"doc":"String manipulation helpers.","ref":"JSONAPI.Utils.String.html","title":"JSONAPI.Utils.String","type":"module"},{"doc":"Replace underscores or dashes between words in value with camelCasing Ignores underscores or dashes that are not between letters/numbers Examples iex&gt; camelize ( &quot;top_posts&quot; ) &quot;topPosts&quot; iex&gt; camelize ( :top_posts ) &quot;topPosts&quot; iex&gt; camelize ( &quot;_top_posts&quot; ) &quot;_topPosts&quot; iex&gt; camelize ( &quot;_top__posts_&quot; ) &quot;_top__posts_&quot; iex&gt; camelize ( &quot;&quot; ) &quot;&quot; iex&gt; camelize ( &quot;alreadyCamelized&quot; ) &quot;alreadyCamelized&quot;","ref":"JSONAPI.Utils.String.html#camelize/1","title":"JSONAPI.Utils.String.camelize/1","type":"function"},{"doc":"Replace underscores between words in value with dashes Ignores underscores that are not between letters/numbers Examples iex&gt; dasherize ( &quot;top_posts&quot; ) &quot;top-posts&quot; iex&gt; dasherize ( &quot;_top_posts&quot; ) &quot;_top-posts&quot; iex&gt; dasherize ( &quot;_top__posts_&quot; ) &quot;_top__posts_&quot;","ref":"JSONAPI.Utils.String.html#dasherize/1","title":"JSONAPI.Utils.String.dasherize/1","type":"function"},{"doc":"Examples iex&gt; expand_fields ( %{ &quot;foo-bar&quot; =&gt; &quot;baz&quot; } , &amp; underscore / 1 ) %{ &quot;foo_bar&quot; =&gt; &quot;baz&quot; } iex&gt; expand_fields ( %{ &quot;foo_bar&quot; =&gt; &quot;baz&quot; } , &amp; dasherize / 1 ) %{ &quot;foo-bar&quot; =&gt; &quot;baz&quot; } iex&gt; expand_fields ( %{ &quot;foo-bar&quot; =&gt; &quot;baz&quot; } , &amp; camelize / 1 ) %{ &quot;fooBar&quot; =&gt; &quot;baz&quot; } iex&gt; expand_fields ( { &quot;foo-bar&quot; , &quot;dollar-sol&quot; } , &amp; underscore / 1 ) { &quot;foo_bar&quot; , &quot;dollar-sol&quot; } iex&gt; expand_fields ( { &quot;foo-bar&quot; , %{ &quot;a-d&quot; =&gt; &quot;z-8&quot; } } , &amp; underscore / 1 ) { &quot;foo_bar&quot; , %{ &quot;a_d&quot; =&gt; &quot;z-8&quot; } } iex&gt; expand_fields ( %{ &quot;f-b&quot; =&gt; %{ &quot;a-d&quot; =&gt; &quot;z&quot; } , &quot;c-d&quot; =&gt; &quot;e&quot; } , &amp; underscore / 1 ) %{ &quot;f_b&quot; =&gt; %{ &quot;a_d&quot; =&gt; &quot;z&quot; } , &quot;c_d&quot; =&gt; &quot;e&quot; } iex&gt; expand_fields ( %{ &quot;f-b&quot; =&gt; %{ &quot;a-d&quot; =&gt; %{ &quot;z-w&quot; =&gt; &quot;z&quot; } } , &quot;c-d&quot; =&gt; &quot;e&quot; } , &amp; underscore / 1 ) %{ &quot;f_b&quot; =&gt; %{ &quot;a_d&quot; =&gt; %{ &quot;z_w&quot; =&gt; &quot;z&quot; } } , &quot;c_d&quot; =&gt; &quot;e&quot; } iex&gt; expand_fields ( :&quot;foo-bar&quot; , &amp; underscore / 1 ) &quot;foo_bar&quot; iex&gt; expand_fields ( :foo_bar , &amp; dasherize / 1 ) &quot;foo-bar&quot; iex&gt; expand_fields ( :&quot;foo-bar&quot; , &amp; camelize / 1 ) &quot;fooBar&quot; iex&gt; expand_fields ( %{ &quot;f-b&quot; =&gt; &quot;a-d&quot; } , &amp; underscore / 1 ) %{ &quot;f_b&quot; =&gt; &quot;a-d&quot; } iex&gt; expand_fields ( %{ &quot;inserted-at&quot; =&gt; ~N[2019-01-17 03:27:24.776957] } , &amp; underscore / 1 ) %{ &quot;inserted_at&quot; =&gt; ~N[2019-01-17 03:27:24.776957] } iex&gt; expand_fields ( %{ &quot;xValue&quot; =&gt; 123 } , &amp; underscore / 1 ) %{ &quot;x_value&quot; =&gt; 123 } iex&gt; expand_fields ( %{ &quot;attributes&quot; =&gt; %{ &quot;corgiName&quot; =&gt; &quot;Wardel&quot; } } , &amp; underscore / 1 ) %{ &quot;attributes&quot; =&gt; %{ &quot;corgi_name&quot; =&gt; &quot;Wardel&quot; } } iex&gt; expand_fields ( %{ &quot;attributes&quot; =&gt; %{ &quot;corgiName&quot; =&gt; [ &quot;Wardel&quot; ] } } , &amp; underscore / 1 ) %{ &quot;attributes&quot; =&gt; %{ &quot;corgi_name&quot; =&gt; [ &quot;Wardel&quot; ] } } iex&gt; expand_fields ( %{ &quot;attributes&quot; =&gt; %{ &quot;someField&quot; =&gt; [ &quot;SomeValue&quot; , %{ &quot;nestedField&quot; =&gt; &quot;Value&quot; } ] } } , &amp; underscore / 1 ) %{ &quot;attributes&quot; =&gt; %{ &quot;some_field&quot; =&gt; [ &quot;SomeValue&quot; , %{ &quot;nested_field&quot; =&gt; &quot;Value&quot; } ] } } iex&gt; expand_fields ( [ %{ &quot;fooBar&quot; =&gt; &quot;a&quot; } , %{ &quot;fooBar&quot; =&gt; &quot;b&quot; } ] , &amp; underscore / 1 ) [ %{ &quot;foo_bar&quot; =&gt; &quot;a&quot; } , %{ &quot;foo_bar&quot; =&gt; &quot;b&quot; } ] iex&gt; expand_fields ( [ %{ &quot;foo_bar&quot; =&gt; &quot;a&quot; } , %{ &quot;foo_bar&quot; =&gt; &quot;b&quot; } ] , &amp; camelize / 1 ) [ %{ &quot;fooBar&quot; =&gt; &quot;a&quot; } , %{ &quot;fooBar&quot; =&gt; &quot;b&quot; } ] iex&gt; expand_fields ( %{ &quot;fooAttributes&quot; =&gt; [ %{ &quot;fooBar&quot; =&gt; &quot;a&quot; } , %{ &quot;fooBar&quot; =&gt; &quot;b&quot; } ] } , &amp; underscore / 1 ) %{ &quot;foo_attributes&quot; =&gt; [ %{ &quot;foo_bar&quot; =&gt; &quot;a&quot; } , %{ &quot;foo_bar&quot; =&gt; &quot;b&quot; } ] } iex&gt; expand_fields ( %{ &quot;foo_attributes&quot; =&gt; [ %{ &quot;foo_bar&quot; =&gt; &quot;a&quot; } , %{ &quot;foo_bar&quot; =&gt; &quot;b&quot; } ] } , &amp; camelize / 1 ) %{ &quot;fooAttributes&quot; =&gt; [ %{ &quot;fooBar&quot; =&gt; &quot;a&quot; } , %{ &quot;fooBar&quot; =&gt; &quot;b&quot; } ] } iex&gt; expand_fields ( %{ &quot;foo_attributes&quot; =&gt; [ %{ &quot;foo_bar&quot; =&gt; [ 1 , 2 ] } ] } , &amp; camelize / 1 ) %{ &quot;fooAttributes&quot; =&gt; [ %{ &quot;fooBar&quot; =&gt; [ 1 , 2 ] } ] }","ref":"JSONAPI.Utils.String.html#expand_fields/2","title":"JSONAPI.Utils.String.expand_fields/2","type":"function"},{"doc":"The configured transformation for the API's fields. JSON:API v1.1 recommends using camlized fields (e.g. &quot;goodDog&quot;, versus &quot;good_dog&quot;). However, we don't hold a strong opinion, so feel free to customize it how you would like (e.g. &quot;good-dog&quot;, versus &quot;good_dog&quot;). This library currently supports camelized, dashed and underscored fields. Configuration examples camelCase fields: config :jsonapi , field_transformation : :camelize Dashed fields: config :jsonapi , field_transformation : :dasherize Underscored fields: config :jsonapi , field_transformation : :underscore","ref":"JSONAPI.Utils.String.html#field_transformation/0","title":"JSONAPI.Utils.String.field_transformation/0","type":"function"},{"doc":"Replace dashes between words in value with underscores Ignores dashes that are not between letters/numbers Examples iex&gt; underscore ( &quot;top-posts&quot; ) &quot;top_posts&quot; iex&gt; underscore ( :top_posts ) &quot;top_posts&quot; iex&gt; underscore ( &quot;-top-posts&quot; ) &quot;-top_posts&quot; iex&gt; underscore ( &quot;-top--posts-&quot; ) &quot;-top--posts-&quot; iex&gt; underscore ( &quot;corgiAge&quot; ) &quot;corgi_age&quot;","ref":"JSONAPI.Utils.String.html#underscore/1","title":"JSONAPI.Utils.String.underscore/1","type":"function"},{"doc":"A View is simply a module that defines certain callbacks to configure proper rendering of your JSONAPI documents. defmodule PostView do use JSONAPI.View def fields , do : [ :id , :text , :body ] def type , do : &quot;post&quot; def relationships do [ author : UserView , comments : CommentView ] end end defmodule UserView do use JSONAPI.View def fields , do : [ :id , :username ] def type , do : &quot;user&quot; def relationships , do : [ ] end defmodule CommentView do use JSONAPI.View def fields , do : [ :id , :text ] def type , do : &quot;comment&quot; def relationships do [ user : { UserView , :include } ] end end defmodule DogView do use JSONAPI.View , namespace : &quot;/pupperz-api&quot; end You can now call UserView.show(user, conn, conn.params) and it will render a valid jsonapi doc. Fields By default, the resulting JSON document consists of fields, defined in the fields/0 function. You can define custom fields or override current fields by defining a 2-arity function inside the view that takes data and conn as arguments and has the same name as the field it will be producing. Refer to our fullname/2 example below. defmodule UserView do use JSONAPI.View def fullname ( data , conn ) , do : &quot;fullname&quot; def fields , do : [ :id , :username , :fullname ] def type , do : &quot;user&quot; def relationships , do : [ ] end Fields may be omitted manually using the hidden/1 function. defmodule UserView do use JSONAPI.View def fields , do : [ :id , :username , :email ] def type , do : &quot;user&quot; def hidden ( _data ) do [ :email ] # will be removed from the response end end In order to use sparse fieldsets you must include the JSONAPI.QueryParser plug. If you want to fetch fields from the given data dynamically , you can use the get_field/3 callback. defmodule UserView do use JSONAPI.View def fields , do : [ :id , :username , :email ] def type , do : &quot;user&quot; def get_field ( field , data , _conn ) do Map . fetch! ( data , field ) end end Relationships Currently the relationships callback expects that a map is returned configuring the information you will need. If you have the following Ecto Model setup defmodule User do schema &quot;users&quot; do field :username has_many :posts has_one :image end end and the includes setup from above. If your Post has loaded the author and the query asks for it then it will be loaded. So for example: GET /posts?include=post.author if the author record is loaded on the Post, and you are using the JSONAPI.QueryParser it will be included in the includes section of the JSONAPI document. If you always want to include a relationship. First make sure its always preloaded and then use the [user: {UserView, :include}] syntax in your includes function. This tells the serializer to always include if its loaded. Options :host (binary) - Allows the host to be overridden for generated URLs. Defaults to host of the supplied conn . :scheme (atom) - Enables configuration of the HTTP scheme for generated URLS. Defaults to scheme from the provided conn . :namespace (binary) - Allows the namespace of a given resource. This may be configured globally or overridden on the View itself. Note that if you have a globally defined namespace and need to remove the namespace for a resource, set the namespace to a blank String. The default behaviour for host and scheme is to derive it from the conn provided, while the default style for presentation in names is to be underscored and not dashed.","ref":"JSONAPI.View.html","title":"JSONAPI.View","type":"behaviour"},{"doc":"","ref":"JSONAPI.View.html#c:attributes/2","title":"JSONAPI.View.attributes/2","type":"callback"},{"doc":"","ref":"JSONAPI.View.html#c:fields/0","title":"JSONAPI.View.fields/0","type":"callback"},{"doc":"","ref":"JSONAPI.View.html#c:get_field/3","title":"JSONAPI.View.get_field/3","type":"callback"},{"doc":"","ref":"JSONAPI.View.html#c:hidden/1","title":"JSONAPI.View.hidden/1","type":"callback"},{"doc":"","ref":"JSONAPI.View.html#c:id/1","title":"JSONAPI.View.id/1","type":"callback"},{"doc":"","ref":"JSONAPI.View.html#c:links/2","title":"JSONAPI.View.links/2","type":"callback"},{"doc":"","ref":"JSONAPI.View.html#c:meta/2","title":"JSONAPI.View.meta/2","type":"callback"},{"doc":"","ref":"JSONAPI.View.html#c:namespace/0","title":"JSONAPI.View.namespace/0","type":"callback"},{"doc":"","ref":"JSONAPI.View.html#c:pagination_links/4","title":"JSONAPI.View.pagination_links/4","type":"callback"},{"doc":"","ref":"JSONAPI.View.html#c:path/0","title":"JSONAPI.View.path/0","type":"callback"},{"doc":"","ref":"JSONAPI.View.html#c:relationships/0","title":"JSONAPI.View.relationships/0","type":"callback"},{"doc":"","ref":"JSONAPI.View.html#c:type/0","title":"JSONAPI.View.type/0","type":"callback"},{"doc":"","ref":"JSONAPI.View.html#c:url_for/2","title":"JSONAPI.View.url_for/2","type":"callback"},{"doc":"","ref":"JSONAPI.View.html#url_for/3","title":"JSONAPI.View.url_for/3","type":"function"},{"doc":"","ref":"JSONAPI.View.html#c:url_for_pagination/3","title":"JSONAPI.View.url_for_pagination/3","type":"callback"},{"doc":"","ref":"JSONAPI.View.html#url_for_pagination/4","title":"JSONAPI.View.url_for_pagination/4","type":"function"},{"doc":"","ref":"JSONAPI.View.html#c:url_for_rel/3","title":"JSONAPI.View.url_for_rel/3","type":"callback"},{"doc":"","ref":"JSONAPI.View.html#url_for_rel/4","title":"JSONAPI.View.url_for_rel/4","type":"function"},{"doc":"","ref":"JSONAPI.View.html#c:visible_fields/2","title":"JSONAPI.View.visible_fields/2","type":"callback"},{"doc":"","ref":"JSONAPI.View.html#visible_fields/3","title":"JSONAPI.View.visible_fields/3","type":"function"},{"doc":"","ref":"JSONAPI.View.html#t:data/0","title":"JSONAPI.View.data/0","type":"type"},{"doc":"","ref":"JSONAPI.View.html#t:field/0","title":"JSONAPI.View.field/0","type":"type"},{"doc":"","ref":"JSONAPI.View.html#t:links/0","title":"JSONAPI.View.links/0","type":"type"},{"doc":"","ref":"JSONAPI.View.html#t:meta/0","title":"JSONAPI.View.meta/0","type":"type"},{"doc":"","ref":"JSONAPI.View.html#t:options/0","title":"JSONAPI.View.options/0","type":"type"},{"doc":"","ref":"JSONAPI.View.html#t:resource_id/0","title":"JSONAPI.View.resource_id/0","type":"type"},{"doc":"","ref":"JSONAPI.View.html#t:resource_type/0","title":"JSONAPI.View.resource_type/0","type":"type"},{"doc":"","ref":"JSONAPI.View.html#t:t/0","title":"JSONAPI.View.t/0","type":"type"},{"doc":"Defines a generic exception for when an invalid query is received and is unable to be parsed nor handled. All JSONAPI exceptions on index routes return a 400.","ref":"JSONAPI.Exceptions.InvalidQuery.html","title":"JSONAPI.Exceptions.InvalidQuery","type":"exception"},{"doc":"A project that will render your data models into JSONAPI Documents and parse/verify JSONAPI query strings.","ref":"readme.html","title":"JSONAPI Elixir","type":"extras"},{"doc":"This library implements version 1.1 of the JSON:API spec. [x] Basic JSONAPI Document encoding [x] Basic support for compound documents [x] Links [x] Relationship links [x] Parsing of sort query parameter into Ecto Query order_by [x] Parsing and limiting of filter keywords. [x] Handling of sparse fieldsets [x] Handling of includes [x] Handling of pagination [x] Handling of top level meta data","ref":"readme.html#jsonapi-support","title":"JSONAPI Elixir - JSONAPI Support","type":"extras"},{"doc":"Full docs here JSON API Spec (v1.1)","ref":"readme.html#documentation","title":"JSONAPI Elixir - Documentation","type":"extras"},{"doc":"","ref":"readme.html#badges","title":"JSONAPI Elixir - Badges","type":"extras"},{"doc":"Installation Add the following line to your mix.deps file with the desired version to install jsonapi . defp deps do [ ... { :jsonapi , &quot;~&gt; x.x.x&quot; } ... ] Usage Simply add use JSONAPI.View either to the top of your view, or to the web.ex view section and add the proper functions to your view like so. defmodule MyApp.PostView do use JSONAPI.View , type : &quot;posts&quot; def fields do [ :text , :body , :excerpt ] end def excerpt ( post , _conn ) do String . slice ( post . body , 0 .. 5 ) end def meta ( data , _conn ) do # this will add meta to each record # To add meta as a top level property, pass as argument to render function (shown below) %{ meta_text : &quot;meta_ \#{ data [ :text ] } &quot; } end def relationships do # The post&#39;s author will be included by default [ author : { MyApp.UserView , :include } , comments : MyApp.CommentView ] end end You can now call render(conn, MyApp.PostView, &quot;show.json&quot;, %{data: my_data, meta: meta}) or &quot;index.json&quot; normally. If you'd like to use this without Phoenix simply use the JSONAPI.View and call JSONAPI.Serializer.serialize(MyApp.PostView, data, conn, meta) .","ref":"readme.html#how-to-use-with-phoenix","title":"JSONAPI Elixir - How to use with Phoenix","type":"extras"},{"doc":"If a relationship has a different name in the backend than you would like it to in your API, you can rewrite its name in the JSONAPI.View . You pair the view with the name of the relationship used in the data (e.g. Ecto schema) to achieve this. Note that you can use a triple instead of a pair to add the instruction to always include the relation if desired. defmodule MyApp.PostView do use JSONAPI.View , type : &quot;posts&quot; def relationships do # The `author` will be exposed as `creator` and the `comments` will be # exposed as `critiques` (for some reason). [ creator : { :author , MyApp.UserView , :include } , critiques : { :comments , MyApp.CommentView } ] end end","ref":"readme.html#renaming-relationships","title":"JSONAPI Elixir - Renaming relationships","type":"extras"},{"doc":"In your controller you may add plug JSONAPI.QueryParser , filter : ~w(name) , sort : ~w(name title inserted_at) , view : PostView This will add a JSONAPI.Config struct called jsonapi_query to your conn.assigns . If a user tries to sort, filter, include, or requests an invalid fieldset it will raise a Plug error that shows the proper error message. The config holds the values parsed into things that are easy to pass into an Ecto query, for example sort=-name will be parsed into sort: [desc: :name] which can be passed directly to the order_by in Ecto. This sort of behavior is consistent for includes. The JSONAPI.QueryParser plug also supports sparse fieldsets . Please see its documentation for details.","ref":"readme.html#parsing-and-validating-a-jsonapi-request","title":"JSONAPI Elixir - Parsing and validating a JSONAPI Request","type":"extras"},{"doc":"JSONAPI has recommended in the past the use of dashes ( - ) in place of underscore ( _ ) as a word separator for document member keys. However, as of JSON API Spec (v1.1) , it is now recommended that member names are camelCased. This library provides various configuration options for maximum flexibility including serializing outgoing parameters and deserializing incoming parameters. Transforming fields requires two steps: camelCase outgoing fields requires you to set the :field_transformation configuration option. Example: config :jsonapi , field_transformation : :camelize # or dasherize Underscoring incoming params (both query and body) requires you add the JSONAPI.UnderscoreParameters Plug to your API's pipeline. This makes it easy to work with changeset data. pipeline :api do plug JSONAPI.EnsureSpec plug JSONAPI.UnderscoreParameters end JSONAPI.Deserializer is a plug designed to make a JSON:API resource object more convenient to work with when creating or updating resources. This plug works by taking the resource object format and flattening it into an easier to manipulate Map. Note that the deserializer expects the same casing for your outgoing params as your incoming params. Your pipeline in a Phoenix app might look something like this: pipeline :api do plug JSONAPI.EnsureSpec plug JSONAPI.Deserializer plug JSONAPI.UnderscoreParameters end","ref":"readme.html#camelized-or-dasherized-fields","title":"JSONAPI Elixir - Camelized or Dasherized Fields","type":"extras"},{"doc":"We include a set of Plugs to make enforcing the JSONAPI spec for requests easy. To add spec enforcement to your application, add JSONAPI.EnsureSpec to your pipeline: plug JSONAPI.EnsureSpec Under-the-hood JSONAPI.EnsureSpec relies on four individual plugs: JSONAPI.ContentTypeNegotiation — Requires the Content-Type and Accept headers are set correctly. JSONAPI.FormatRequired — Verifies that the JSON body matches the expected %{data: %{attributes: attributes}} format. JSONAPI.IdRequired — Confirm the id key is present in %{data: data} and that it matches the resource's id in the URI. JSONAPI.ResponseContentType — Ensures that you return the correct Content-Type header.","ref":"readme.html#spec-enforcement","title":"JSONAPI Elixir - Spec Enforcement","type":"extras"},{"doc":"config :jsonapi , host : &quot;www.someotherhost.com&quot; , scheme : &quot;https&quot; , namespace : &quot;/api&quot; , field_transformation : :underscore , remove_links : false , json_library : Jason , paginator : nil host , scheme . By default these are pulled from the conn , but may be overridden. namespace . This optional setting can be used to configure the namespace your resources live at (e.g. given &quot; http://example.com/api/cars&quot; , &quot;/api&quot; would be the namespace). See also JSONAPI.View for setting on the resource's View itself. field_transformation . This option describes how your API's fields word boundaries are marked. JSON API Spec (v1.1) recommends using camelCase (e.g. &quot;favoriteColor&quot;: blue ). If your API uses camelCase fields, set this value to :camelize . JSON:API v1.0 recommended using a dash (e.g. &quot;favorite-color&quot;: blue ). If your API uses dashed fields, set this value to :dasherize . If your API uses underscores (e.g. &quot;favorite_color&quot;: &quot;red&quot; ) set to :underscore . remove_links . links data can optionally be removed from the payload via setting the configuration above to true . Defaults to false . json_library . Defaults to Jason . paginator . Module implementing pagination links generation. Defaults to nil .","ref":"readme.html#configuration","title":"JSONAPI Elixir - Configuration","type":"extras"},{"doc":"Pagination links can be generated by overriding the JSONAPI.View.pagination_links/4 callback of your view and returning a map containing the links. ... def pagination_links ( data , conn , page , options ) do %{ first : nil , last : nil , prev : nil , next : nil } end ... Alternatively you can define generic pagination strategies by implementing a module conforming to the JSONAPI.Paginator behavior defmodule PageBasedPaginator do @moduledoc &quot;&quot;&quot; Page based pagination strategy &quot;&quot;&quot; @behaviour JSONAPI.Paginator @impl true def paginate ( data , view , conn , page , options ) do number = page |&gt; Map . get ( &quot;page&quot; , &quot;0&quot; ) |&gt; String . to_integer ( ) size = page |&gt; Map . get ( &quot;size&quot; , &quot;0&quot; ) |&gt; String . to_integer ( ) total_pages = Keyword . get ( options , :total_pages , 0 ) %{ first : view . url_for_pagination ( data , conn , Map . put ( page , &quot;page&quot; , &quot;1&quot; ) ) , last : view . url_for_pagination ( data , conn , Map . put ( page , &quot;page&quot; , total_pages ) ) , next : next_link ( data , view , conn , number , size , total_pages ) , prev : previous_link ( data , view , conn , number , size ) } end defp next_link ( data , view , conn , page , size , total_pages ) when page &lt; total_pages , do : view . url_for_pagination ( data , conn , %{ size : size , page : page + 1 } ) defp next_link ( _data , _view , _conn , _page , _size , _total_pages ) , do : nil defp previous_link ( data , view , conn , page , size ) when page &gt; 1 , do : view . url_for_pagination ( data , conn , %{ size : size , page : page - 1 } ) defp previous_link ( _data , _view , _conn , _page , _size ) , do : nil end and configuring it as the global pagination logic in your mix.config config :jsonapi , :paginator , PageBasedPaginator or as the view pagination logic when using JSONAPI.View use JSONAPI.View , paginator : PageBasedPaginator Links can be generated using the JSONAPI.Config.page information stored in the connection assign jsonapi_query and by passing additional information to the pagination_links/4 callback or your paginator module by passing options from your controller. Actual pagination is expected to be handled in your application logic and is outside the scope of this library.","ref":"readme.html#pagination","title":"JSONAPI Elixir - Pagination","type":"extras"},{"doc":"Feel free to make PR's. I will do my best to respond within a day or two. If you want to take one of the TODO items just create an issue or PR and let me know so we avoid duplication. If you need help, I am on irc and twitter. Example project","ref":"readme.html#other","title":"JSONAPI Elixir - Other","type":"extras"}]